Index: /trunk/sources/HeuristicLab.Visualization/3.2/Legend/LegendItem.cs
===================================================================
--- /trunk/sources/HeuristicLab.Visualization/3.2/Legend/LegendItem.cs	(revision 1876)
+++ /trunk/sources/HeuristicLab.Visualization/3.2/Legend/LegendItem.cs	(revision 1877)
@@ -4,6 +4,14 @@
   public class LegendItem {
 
+    // default width
+    // every legend under 100 gets the default width
     public static readonly int WIDTH = 100;
 
+    /// <summary>
+    /// a legend item object with its properties
+    /// </summary>
+    /// <param name="label">the label of the legend</param>
+    /// <param name="color">the color of the legend line</param>
+    /// <param name="thickness">the thickness of the legend line</param>
     public LegendItem(string label, Color color, int thickness) {
       Label = label;
Index: /trunk/sources/HeuristicLab.Visualization/3.2/Legend/LegendShape.cs
===================================================================
--- /trunk/sources/HeuristicLab.Visualization/3.2/Legend/LegendShape.cs	(revision 1876)
+++ /trunk/sources/HeuristicLab.Visualization/3.2/Legend/LegendShape.cs	(revision 1877)
@@ -1,3 +1,2 @@
-using System;
 using System.Collections.Generic;
 using System.Drawing;
@@ -14,22 +13,13 @@
     private readonly IList<LegendItem> legendItems = new List<LegendItem>();
     // legend draw default value: column
-    private bool row;
-    private bool top;
 
     private Color color = Color.Blue;
     private Font font = new Font("Arial", 8);
 
+    public bool Row { get; set; }
+    public bool Top { get; set; }
+
     public LegendShape() {
       CreateLegend();
-    }
-
-    public bool Row {
-      set { row = value; }
-      get { return row; }
-    }
-
-    public bool Top {
-      set { top = value; }
-      get { return top; }
     }
 
@@ -47,10 +37,10 @@
         double y = ClippingArea.Y2;
 
-        if (row && !top) {
+        if (Row && !Top) {
           y = GetOptimalBottomHeight();
         }
         int legendItemCounter = 1;
         foreach (LegendItem item in legendItems) {
-          if (!row) {
+          if (!Row) {
             CreateColumn(item, y);
             y -= Font.Height;
@@ -68,4 +58,8 @@
     }
 
+    /// <summary>
+    /// calculates the optimal height, when the legend shall be draw at the bottom
+    /// </summary>
+    /// <returns>optimal bottom height</returns>
     private double GetOptimalBottomHeight() {
       int rowsToDraw = 1;
@@ -78,28 +72,12 @@
     }
 
-    ///// <summary>
-    ///// returns the maximum number of items per row to paint
-    ///// </summary>
-    ///// <returns>number of items per row</returns>
-    //public int GetNrOfItemsPerRow() {
-    //  double sum = 0;
-    //  double caw = ClippingArea.Width;
-    //  int items = 0;
-    //  foreach (var item in legendItems) {
-    //    sum += GetLabelLengthInPixel(item);
-    //    if (sum < caw) {
-    //      items++;
-    //    }
-    //  }
-    //  if (items == 0) {
-    //    items++;
-    //  }
-    //  return items;
-    //}
-
-    /// <summary>
-    /// returns the maximum number of items per row to paint
-    /// </summary>
-    /// <returns>number of items per row</returns>
+    /// <summary>
+    /// returns a boolean value, if the new legend item has to be paint in a 
+    /// new row
+    /// </summary>
+    /// <returns>
+    ///   true, draw legend item in a new row
+    ///   false, draw the legend item in the current row
+    /// </returns>
     private bool IsNewRow(int toCurrentItem) {
       double sum = 0;
@@ -117,6 +95,6 @@
     /// returns the length of the current legenditem in pixel
     /// </summary>
-    /// <param name="item"></param>
-    /// <returns></returns>
+    /// <param name="item">legend item to calculate the length</param>
+    /// <returns>length of the legend item</returns>
     private int GetLabelLengthInPixel(LegendItem item) {
       int dummy = (int)(item.Label.Length*Font.Size + 20);
@@ -145,5 +123,5 @@
     private void CreateColumn(LegendItem item, double y) {
       AddShape(new LineShape(10, y - (Font.Height / 2), 30, y - (Font.Height / 2), item.Color, item.Thickness, DrawingStyle.Solid));
-      AddShape(new TextShape(Font.Height+12, y, item.Label, Font, Color));
+      AddShape(new TextShape(35, y, item.Label, Font, Color));//Font.Height+12
     }
 
@@ -158,5 +136,5 @@
     /// <summary>
     /// searches the longest label and returns it with factor of the the current font size
-    /// useful to set the width of the legend
+    /// useful to set the width of the legend area on the left or right side
     /// </summary>
     /// <returns>max label length with factor of the current font size</returns>
Index: /trunk/sources/HeuristicLab.Visualization/3.2/Options/ViewSettings.cs
===================================================================
--- /trunk/sources/HeuristicLab.Visualization/3.2/Options/ViewSettings.cs	(revision 1876)
+++ /trunk/sources/HeuristicLab.Visualization/3.2/Options/ViewSettings.cs	(revision 1877)
@@ -24,5 +24,5 @@
       xAxisColor = Color.Blue;
 
-      legendPosition = LegendPosition.Bottom;
+      legendPosition = LegendPosition.Right;
     }
 